/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODOCORRE                                               */
/* Tabela : PRODOCORRE                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 10/05/2006 - Danilo Onofre Raposo Carvalho                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRODOCORRE'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_PRODOCORRE
  GO

CREATE TRIGGER DTULTATU_PRODOCORRE
ON PRODOCORRE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODOCORRE', 'CDGRPOCOR='+DELETED.CDGRPOCOR+';'+'CDOCORR='+DELETED.CDOCORR+';'+'CDPRODUTO='+DELETED.CDPRODUTO+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODOCORRE
      SET DTULTATUPOCO = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(PRODOCORRE.CDGRPOCOR,0) = ISNULL(INSERTED.CDGRPOCOR,0)) AND
            (ISNULL(PRODOCORRE.CDOCORR  ,0) = ISNULL(INSERTED.CDOCORR  ,0)) AND
            (ISNULL(PRODOCORRE.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0));
   END;
END;
GO

UPDATE PRODOCORRE SET DTULTATUPOCO = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUPOCO IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUPOCO' and
            type = 'D')
   ALTER TABLE PRODOCORRE DROP CONSTRAINT DEFAULT_DTULTATUPOCO
GO

ALTER TABLE PRODOCORRE ADD CONSTRAINT DEFAULT_DTULTATUPOCO
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUPOCO
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PRODOCORRE','4.11.194';
GO

