import {Metric} from './Mask/Metric';
import {Currency} from './Mask/Currency';
import {Float} from './Mask/Float';
import {Percentage} from './Mask/Percentage';
import {Date} from './Mask/Date';
import {Time} from './Mask/Time';

export class ChartViewService {

    public static getMaskFunction(mask: string) {
        let maskFunction;
        switch (mask) {
            case 'metric':
                maskFunction = Metric.getFunction();
                break;
            case 'currency':
                    maskFunction = Currency.getFunction();
                break;
            case 'float':
                    maskFunction = Float.getFunction();
                    break;
            case 'percent':
                    maskFunction = Percentage.getFunction();
                    break;
            case 'date':
                    maskFunction = Date.getFunction();
                    break;
            case 'time':
                    maskFunction = Time.getFunction();
                    break;
            default:
                maskFunction = this.notMask.bind(this);
                break;
        }
        return maskFunction;
    }

    public static getMaskFunctionDynamic(value: any, params: any) {
        const serieIndex = params.seriesIndex;
        const mask = params.w.config.yaxis[serieIndex].mask;
        return ChartViewService.getMaskFunction(mask)(value);
    }

    public static notMask(value: any) {
        return value;
    }
}
